def encode(s):
    ans = ''
    l = 0
    r = 0
    while l < len(s):
        while r + 1 < len(s) and s[r] == s[r + 1]:
            r += 1
        if r - l + 1 == 1:
            ans += s[r]
        else:
            ans += str(r - l + 1) + s[r]
        l = r + 1
        r += 1
    return ans


def decode(s):
    ans = ''
    i = 0
    while i < len(s):
        if s[i].isdigit():
            ans += int(s[i]) * s[i + 1]
            i += 2
        else:
            ans += s[i]
            i += 1
    return ans


s = input()
s = decode(s)
min_len = 10 ** 10
max_len = -1
ans_min = 0
ans_max = 0
ans_type_min = 0
ans_type_max = 0
ans_symbol_min = ''
ans_symbol_max = ''
for i in range(len(s) + 1):
    if i != len(s):
        t1 = len(encode(s[:i] + s[i + 1:]))
        if t1 > max_len:
            max_len = t1
            ans_max = i
            ans_type_max = 2
        if t1 < min_len:
            min_len = t1
            ans_type_min = 2
            ans_min = i
    for k in {"A", "G", "C", "T"}:
        t2 = len(encode(s[:i] + k + s[i:]))
        if t2 > max_len:
            max_len = t2
            ans_type_max = 1
            ans_max = i
            ans_symbol_max = k
        if t2 < min_len:
            min_len = t2
            ans_min = i
            ans_type_min = 1
            ans_symbol_min = k
        if i != len(s) and s[i] != k:
            t3 = len(encode(s[:i] + k + s[i + 1:]))
            if t3 > max_len:
                max_len = t3
                ans_max = i
                ans_type_max = 3
                ans_symbol_max = k
            if t3 < min_len:
                min_len = t3
                ans_min = i
                ans_type_min = 3
                ans_symbol_min = k

if ans_type_min == 2:
    print(ans_type_min, ans_min + 1)
elif ans_type_min == 1:
    print(ans_type_min, ans_min, ans_symbol_min)
else:
    print(ans_type_min, ans_min + 1, ans_symbol_min)

if ans_type_max == 2:
    print(ans_type_max, ans_max + 1)
elif ans_type_max == 1:
    print(ans_type_max, ans_max, ans_symbol_max)
else:
    print(ans_type_max, ans_max + 1, ans_symbol_max)
